using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Text;


namespace neorbe
{
	static class Program
	{
		static void Main()
		{
			string text = File.ReadAllText("endo.prefix") + File.ReadAllText("endo.dna");
			StreamWriter writer = new StreamWriter("rna");
			Dna dna = DnaFromString(text);
			DnaSimulator sim = new DnaSimulator(dna, writer);
			sim.Simulate();
			writer.Close();
		}

		static Dna DnaFromString(string text)
		{
			byte[] data = new byte[text.Length];
			for (int i = 0; i < text.Length; ++i)
			{
				switch (text[i])
				{
					case 'I': data[i] = DnaSimulator.I; break;
					case 'C': data[i] = DnaSimulator.C; break;
					case 'F': data[i] = DnaSimulator.F; break;
					case 'P': data[i] = DnaSimulator.P; break;
					default: throw new Exception();
				}
			}
			return new Dna(data, Dna.Empty);
		}
	}

	public class DnaException : Exception
	{
	}
}
