using System;
using System.Collections.Generic;
using System.Text;


namespace neorbe
{
	public abstract class TemplateItem
	{
		public const int ItemsCode = 0;
		public const int ProtectedCode = 1;
		public const int NumberCode = 2;

		public class Items : TemplateItem
		{
			public readonly byte[] Value;

			public Items(byte[] value)
			{
				this.Value = value;
			}

			public override int Code
			{
				get
				{
					return ItemsCode;
				}
			}
		}

		public class Protected : TemplateItem
		{
			public readonly int Reference;
			public readonly int Protection;

			public Protected(int reference, int protection)
			{
				this.Reference = reference;
				this.Protection = protection;
			}

			public override int Code
			{
				get
				{
					return ProtectedCode;
				}
			}
		}

		public class Number : TemplateItem
		{
			public readonly int Reference;

			public Number(int reference)
			{
				this.Reference = reference;
			}

			public override int Code
			{
				get
				{
					return NumberCode;
				}
			}
		}

		public abstract int Code { get; }
	}
}
