using System;
using System.Collections.Generic;
using System.Text;


namespace neorbe
{
	public static class Utils
	{
		public static T[] Concat<T>(IList<ArraySegment<T>> segments)
		{
			int totalSize = 0;
			foreach (ArraySegment<T> segment in segments)
			{
				totalSize += segment.Count;
			}
			T[] result = new T[totalSize];
			int offset = 0;
			foreach (ArraySegment<T> segment in segments)
			{
				Array.Copy(
					segment.Array, segment.Offset,
					result, offset, segment.Count);
				offset += segment.Count;
			}
			return result;
		}
	}
}
